﻿init python:
    class serve_dish:
        def __init__(self, name, image):
            self.name = name
            self.image = image
    class serve_chick:
        def __init__(self, name, likes, happy, angry):
            self.name = name
            self.likes = likes
            self.happy = happy
            self.angry = angry

    class serve_class:
        def __init__(self, dishes, left, right):
            self.dishes = dishes
            self.current = None
            self.left = left
            self.right = right
            self.drag = None
            self.eating = None
            self.test = 0
        def reset(self):
            self.drag.snap(560,0)
            self.drag.draggable = True
        def spawn(self):
            dish = random.choice(self.dishes)
            self.current = dish
            renpy.play("serve/magic_1.ogg", "sound")
        def drop(self, drags, drop):
            drag = drags[0]
            self.drag = drag
            if drop:
                self.eating = drop.drag_name
                drag.draggable = False
                self.compare(drop.drag_name)
            else:
                drag.snap(560,0)
        def consume(self, p1, p2, p3):
            self.current = None
            self.eating = None
            self.drag.snap(560,0)
            self.drag.draggable = True
            renpy.restart_interaction()
        def compare(self, side):
            if side == "left":
                girl = self.left
            else:
                girl = self.right
            
            if self.current in girl.likes:
                tag = str(random.randint(0, 10000))
                Show("serve_emotion", img = girl.happy, tag = tag, _tag = tag)()
            else:
                tag = str(random.randint(0, 10000))
                Show("serve_emotion", img = girl.angry, tag = tag, _tag = tag)()


transform serve_emotion_animation(tag):
    alpha 0
    ease .1 alpha 1
    pause .4
    ease .1 alpha 0
screen serve_emotion(img, tag):
    add img at serve_emotion_animation(tag)
    timer .7 action Hide(tag)

transform serve_appear():
    yoffset -40 alpha 0
    ease .5 yoffset 0 alpha 1
transform serve_disappear(g):
    alpha 1
    ease .5 alpha 0
    function g.consume

default serve_pudding = serve_dish("Pudding", "serve_pudding")
default serve_shake = serve_dish("Milkshake", "serve_milkshake")
default serve_cake = serve_dish("Cake", "serve_cake")
default serve_soda = serve_dish("Soda", "serve_soda")
screen serve_screen():
    default g = serve_class(
        [serve_shake, serve_cake, serve_soda, serve_pudding],
        serve_chick("Princess War",[serve_cake, serve_soda], "war_happy", "war_angry"),
        serve_chick("Princess Peace",[serve_pudding, serve_shake], "peace_happy", "peace_angry"),
        )
    if not g.current:
        timer 1 repeat True action Function(g.spawn)
    draggroup:
        drag:
            xalign .0 draggable False drag_name "left"
            frame:
                background None xsize 200
        drag:
            xalign 1.0 draggable False drag_name "right"
            frame:
                background None xsize 200
        drag:
            xalign .5
            dragged g.drop
            frame:
                background None xsize 800 yfill True
                if g.current:
                    add g.current.image align .5,1.0:
                        if not g.eating:
                            at serve_appear
                        else:
                            at serve_disappear(g)
    # button:
    #     xoffset 300
    #     text "test"
    #     action Function(g.reset)

label serve_cake_examples:
    scene black
    show bg princesses with dissolve
    call screen serve_screen












